/***************************************************************/
/* Dustin Graves                                               */
/* CSCI 185 10                                                 */
/* 9/16/98                                                     */
/* 9/30/98                                                     */
/* 10/14/98                                                    */
/***************************************************************/

import java.awt.*;

class MyEllipse extends MyGraphicalObject
{

  protected boolean fIs3d;
  protected Point2d fLeftCorner2d;      //Top Left Corner
  protected Point2d fRightCorner2d;     //Bottom Right Corner
  protected Point3d fLeftCorner3d;      //Top Left Corner
  protected Point3d fRightCorner3d;     //Bottom Right Corner
 
  MyEllipse (double xc, double yc, double width, double height)
  {

    //2d object
    fIs3d = false;

    //Store coordinates as bounding box corners for transformations
    fLeftCorner2d = new Point2d (xc - width/2, yc + height/2);
    fRightCorner2d = new Point2d (xc + width/2, yc - height/2);

  } //MyEllipse

  MyEllipse (double xc, double yc, double zc, double width, double height)
  {

    //3d object
    fIs3d = true;

    //Store coordinates as bounding box corners for transformations
    fLeftCorner3d = new Point3d (xc - width/2, yc + height/2, zc);
    fRightCorner3d = new Point3d (xc + width/2, yc - height/2, zc);

  } //MyEllipse

  public void render (Graphics g)
  {
    //Draw ellipse within specified boundaries, 
    //converting bottom right corner values to width and height

    if (fIs3d)
    {
      g.drawOval (xToScreen (fLeftCorner3d.fX), 
                  yToScreen (fLeftCorner3d.fY), 
                  xToScreen (fRightCorner3d.fX - fLeftCorner3d.fX), 
                  yToScreenRaw (fLeftCorner3d.fY - fRightCorner3d.fY));
    }
    else
    {
      g.drawOval (xToScreen (fLeftCorner2d.fX), 
                  yToScreen (fLeftCorner2d.fY), 
                  xToScreen (fRightCorner2d.fX - fLeftCorner2d.fX), 
                  yToScreenRaw (fLeftCorner2d.fY - fRightCorner2d.fY));
    }
  } //render

  public void apply (Xform x)
  {
    //Transform points
    if (fIs3d)
    {
      x.apply (fLeftCorner3d);
      x.apply (fRightCorner3d);
    }
    else
    {
      x.apply (fLeftCorner2d);
      x.apply (fRightCorner2d);
    }
  } //apply

} //MyEllipse
