/***************************************************************/
/* Dustin Graves                                               */
/* CSCI 185 10                                                 */
/* 9/16/98                                                     */
/* 10/14/98                                                    */
/***************************************************************/

import java.awt.*;

class MyPoly extends MyGraphicalObject
{

  protected boolean fIs3d;
  protected Point2d fPoints2d[];      //Vertices
  protected Point3d fPoints3d[];      //Vertices
  protected int fNVerts;            //Number of vertices
 
  //Default constructor for subclasses
  MyPoly ()
  {
  }

  MyPoly (double x[], double y[], int nverts)
  {
    fPoints2d = new Point2d[nverts];
    fNVerts = nverts;
    fIs3d = false;
    
    for (int i = 0; i < nverts; i++)
    {
      fPoints2d[i] = new Point2d (x[i], y[i]);
    }
  } //MyPoly

  MyPoly (double x[], double y[], double z[], int nverts)
  {
    fPoints3d = new Point3d[nverts];
    fNVerts = nverts;
    fIs3d = true;
    
    for (int i = 0; i < nverts; i++)
    {
      fPoints3d[i] = new Point3d (x[i], y[i], z[i]);
    }
  } //MyPoly

  public void render (Graphics g)
  {
    //Copy points to arrays
    int i;
    int xPoints[] = new int[fNVerts];
    int yPoints[] = new int[fNVerts];

    if (fIs3d)
    {
      for (i = 0; i < fNVerts; i++)
      {
        xPoints[i] = xToScreen (fPoints3d[i].fX); 
        yPoints[i] = yToScreen (fPoints3d[i].fY); 
      }
    }
    else
    {
      for (i = 0; i < fNVerts; i++)
      {
        xPoints[i] = xToScreen (fPoints2d[i].fX); 
        yPoints[i] = yToScreen (fPoints2d[i].fY); 
      }
    }

    g.drawPolygon (xPoints, yPoints, fNVerts);
  } //render

  public void apply (Xform x)
  {
    int i;

    if (fIs3d)
    {
      for (i = 0; i < fNVerts; i++)
      {
        //Apply transformation to each point
        fPoints3d[i] = x.apply (fPoints3d[i]);
      }
    }
    else
    {
      for (i = 0; i < fNVerts; i++)
      {
        //Apply transformation to each point
        fPoints2d[i] = x.apply (fPoints2d[i]);
      }
    }
  } //apply

} //MyPoly
